﻿Public Class ScrollButton

    'Definizione dell'indice dell'immagine Nuova, quella che appare dopo avere premuto i tasti SU/GIU' o usato la rotellina
    Private intImmagineNuova As Integer = 0

    'Definizione delle due immagini: quella Vecchia che scompare e quella Nuova che appare
    Private immagineVecchia, immagineNuova As Bitmap

    'Definizione delle coordinate Y delle due immagini
    Private yVecchia, yNuova As Integer

    'Impostazione dei flag per determinare se viene fatta scorrere la lista verso l'alto o verso il basso
    Private scorreSu, scorreGiu As Boolean

    'Impostazione del flag per determinare se il mouse è sopra il pulsante (TRUE) o al di fuori di esso (FALSE)
    Private chkFocus As Boolean = False

    'Impostazione del testo da visualizzare come descrizione
    Private testo As String = Nothing

    'Impostazione del flag per determinare se sono state caricate (TRUE) o meno (FALSE) delle immagini nel pulsante
    Private chkListaInserita As Boolean = False

    'Lista che contiene l'elenco delle immagini
    Private _listaImmagini As New ImageList

    'Lista che contiene l'elenco delle descrizioni
    Private _descrizione As New List(Of String)

    'Definizione dell'evento relativo al click del mouse sullo ScrollButton
    Public Event Icona_MouseClick(ByVal nIcona As Integer)

    Public Sub New()

        InitializeComponent()
        _listaImmagini.ImageSize = New Size(32, 32)
        yVecchia = -34
        yNuova = 4

    End Sub

    ''' <summary>
    ''' Metodo per inserire le immagini da caricare e il relativo testo
    ''' </summary>
    ''' <param name="img">immagine da caricare</param>
    ''' <param name="descr">descrizione allegata</param>
    ''' <remarks></remarks>
    Public Sub InserisciImmagini(ByVal img As Bitmap, ByVal descr As String)

        _listaImmagini.Images.Add(img)
        _descrizione.Add(descr)
        immagineNuova = _listaImmagini.Images.Item(0)
        immagineVecchia = immagineNuova
        chkListaInserita = True

    End Sub

    ''' <summary>
    ''' Metodo per inserire un icona da caricare e il relativo testo
    ''' </summary>
    ''' <param name="icona">icona da caricare</param>
    ''' <param name="descr">descrizione allegata</param>
    ''' <remarks></remarks>
    Public Sub InserisciImmagini(ByVal icona As Icon, ByVal descr As String)

        _listaImmagini.Images.Add(icona)
        _descrizione.Add(descr)
        immagineNuova = _listaImmagini.Images.Item(0)
        immagineVecchia = immagineNuova
        chkListaInserita = True

    End Sub

    ''' <summary>
    ''' Metodo per inserire le immagini da caricare da file e il relativo testo
    ''' </summary>
    ''' <param name="img"></param>
    ''' <param name="descr"></param>
    ''' <remarks></remarks>
    Public Sub InserisciImmagini(ByVal img As String, ByVal descr As String)

        _listaImmagini.Images.Add(Image.FromFile(img))
        _descrizione.Add(descr)
        immagineNuova = _listaImmagini.Images.Item(0)
        immagineVecchia = immagineNuova
        chkListaInserita = True

    End Sub

    'Esposizione e consumo dell'evento Icona_MouseClick
    Private Sub btnIcona_MouseClick(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnIcona.MouseClick

        If _listaImmagini.Images.Empty = True Then Exit Sub

        Dim indice As Integer = intImmagineNuova Mod _listaImmagini.Images.Count

        If indice < 0 Then

            indice = _listaImmagini.Images.Count + indice

        End If

        RaiseEvent Icona_MouseClick(indice)

    End Sub

    'Evento per ottenere il focus sul pulsante quando il mouse vi staziona sopra
    Private Sub btnIcona_MouseHover(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnIcona.MouseHover

        Me.btnIcona.Focus()

    End Sub

    'Sub per realizzare l'animazione della rotazione delle immagini con l'uso della rotellina
    Private Sub btnIcona_MouseWheel(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles btnIcona.MouseWheel

        Dim chk As Integer = intImmagineNuova
        immagineVecchia = immagineNuova
        intImmagineNuova += CInt(e.Delta / 120)
        Visualizza()

        If (intImmagineNuova - chk) > 0 Then

            yVecchia = 4
            yNuova = 42
            scorreSu = True

        Else

            yVecchia = 4
            yNuova = -34
            scorreGiu = True

        End If

        ToolTip1.SetToolTip(Me.btnIcona, testo)
        ToolTip1.SetToolTip(Me.btnDown, testo)
        ToolTip1.SetToolTip(Me.btnUp, testo)

    End Sub

    'Sub per determinare l'animazione della rotazione delle immagini con l'uso del pulsante GIU'
    Private Sub btnDown_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnDown.Click

        immagineVecchia = immagineNuova
        intImmagineNuova -= 1
        Visualizza()
        yVecchia = 4
        yNuova = -34
        ToolTip1.SetToolTip(Me.btnIcona, testo)
        ToolTip1.SetToolTip(Me.btnDown, testo)
        ToolTip1.SetToolTip(Me.btnUp, testo)
        scorreGiu = True

    End Sub

    'Sub per determinare l'animazione della rotazione delle immagini con l'uso del pulsante SU
    Private Sub btnUp_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnUp.Click

        immagineVecchia = immagineNuova
        intImmagineNuova += 1
        Visualizza()
        yVecchia = 4
        yNuova = 42
        ToolTip1.SetToolTip(Me.btnIcona, testo)
        ToolTip1.SetToolTip(Me.btnDown, testo)
        ToolTip1.SetToolTip(Me.btnUp, testo)
        scorreSu = True

    End Sub

    'Sub per realizzare il movimento di scorrimento verso l'alto o il basso al trascorrere del tempo
    Private Sub Timer1_Tick(ByVal sender As Object, ByVal e As System.EventArgs) Handles Timer1.Tick

        If scorreSu Then

            yVecchia -= 2
            yNuova -= 2
            If yVecchia <= -33 AndAlso yNuova = 4 Then scorreSu = False

        End If

        If scorreGiu Then

            yVecchia += 2
            yNuova += 2
            If yVecchia >= 42 AndAlso yNuova = 4 Then scorreGiu = False

        End If

        Me.btnIcona.Invalidate()

        If scorreGiu = False AndAlso scorreSu = False Then Visualizza()

    End Sub

    'Sub per visualizzare le immagini e il testo caricate all'interno del pulsante
    Private Sub Visualizza()

        If chkListaInserita Then

            Dim numeroImmagini As Integer = _listaImmagini.Images.Count
            Dim valore As Integer = intImmagineNuova Mod numeroImmagini

            For i As Integer = 0 To numeroImmagini - 1

                If i = valore OrElse (i - numeroImmagini) = valore Then

                    immagineNuova = _listaImmagini.Images.Item(i)
                    testo = _descrizione.Item(i)
                    Exit For
                End If

            Next

        End If

    End Sub

    'Sub per disegnare le immagini sul pulsante
    Private Sub btnIcona_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles btnIcona.Paint

        If chkListaInserita Then

            e.Graphics.DrawImage(immagineVecchia, 4, yVecchia, 32, 32)
            e.Graphics.DrawImage(immagineNuova, 4, yNuova, 32, 32)

        End If

    End Sub

End Class

